import {
  Badge,
  Box,
  Button,
  HStack,
  Input,
  Switch,
  Text,
  Tooltip,
  useToast,
  useDisclosure,
  Link,
  useBoolean,
} from "@chakra-ui/react";
import React, { useContext, useEffect, useState } from "react";
import { useNavigate } from "react-router-dom";

import { CheckIcon, CloseIcon, ExternalLinkIcon } from "@chakra-ui/icons";
import { debounce } from "../Admin/Contact";
import { OPACITY_ON_LOAD } from "../../Layout/animations";
import GlobalStateContext from "../../Contexts/GlobalStateContext";
import CustomAlertDialog from "../../Components/CustomAlertDialog";
import ToastBox from "../../Components/ToastBox";
import NormalTable from "../../Components/DataTable/NormalTable";
import { TABLE_PAGINATION } from "../../Constants/Paginations";
import { generateSerialNumber } from "../../Constants/Constants";
import { useGetDepositHistoryQuery } from "../../Services/deposit.request.service";
import Pagination from "../../Components/Pagination";
import ConfirmModal from "./ConfirmModal";
import RejectModal from "./RejectModal";
import {
  useApproveBankDepositRequestMutation,
  useGetBankDepositMasterQuery,
  useRejectbankDepositRequestMutation,
} from "../../Services/bankdeposit.request.service";
import RejectReversalPopups from "../../Components/Popups/RejectReversalPopups";
import ConfirmReversalPopups from "../../Components/Popups/ConfirmReversalPopups";

const formatDate = (date) => {
  return new Date(date).toLocaleDateString("en-GB", {
    day: "2-digit",
    month: "2-digit",
    year: "numeric",
  });
}; // Simple date formatter

const BankDepositRequest = () => {
  const navigate = useNavigate();
  const toast = useToast();
  const { depositHistory, setDepositHistory, slideFromRight } =
    useContext(GlobalStateContext);
  const [isLoading, setIsLoading] = useState(true);
  const [deleteAlert, setDeleteAlert] = useState(false);
  const [actionId, setActionId] = useState(false);
  const [mouseEntered, setMouseEntered] = useState(false);
  const [mouseEnteredId, setMouseEnteredId] = useState("");
  const {
    isOpen: isConfirmOpen,
    onOpen: onConfirmOpen,
    onClose: onConfirmClose,
  } = useDisclosure();
  const {
    isOpen: isRejectOpen,
    onOpen: onRejectOpen,
    onClose: onRejectClose,
  } = useDisclosure();

  // =========================== [Use State] =============================
  const [pageSize, setPageSize] = useState(TABLE_PAGINATION?.size);
  const [currentPage, setCurrentPage] = useState(TABLE_PAGINATION?.page);
  const [searchTerm, setSearchTerm] = useState("");
  const [debouncedSearchTerm, setDebouncedSearchTerm] = useState("");

  const [rejectbankDepositRequest] = useRejectbankDepositRequestMutation();

  const [approveBankDepositRequest] = useApproveBankDepositRequestMutation();

  const [isReversalLoading, setIsReversalLoading] = useBoolean();

  // Debounce the search term to avoid making a request on every keystroke
  useEffect(() => {
    const handler = setTimeout(() => {
      setDebouncedSearchTerm(searchTerm);
    }, 500); // Adjust delay as needed
    return () => {
      clearTimeout(handler);
    };
  }, [searchTerm]);

  const {
    data,
    error,
    refetch,
    isLoading: depositHistoryLoading,
  } = useGetBankDepositMasterQuery(
    {
      page: debouncedSearchTerm ? undefined : currentPage, // Omit pagination for search
      size: debouncedSearchTerm ? undefined : pageSize, // Omit pagination for search
      search: debouncedSearchTerm,
    },
    {
      skip: debouncedSearchTerm === "" && searchTerm !== "", // Skip if search is empty and it's not the initial request
    }
  );

  // Use useEffect to refetch data when the component mounts
  useEffect(() => {
    refetch();
  }, [refetch]);

  // ====================================================[Table Setup]================================================================
  const tableHeadRow = [
    "Sr.no",
    "Request Date",
    "Client ID",
    "First Name",
    "Last Name",
    "Country",
    "Phone Number",
    "Deposit Amount",
    "Action",
  ];

  const handleUpdateStatus = debounce((id) => {
    setDepositHistory((prevDepositHistory) =>
      prevDepositHistory.map((depositHistory) =>
        depositHistory.id === id
          ? { ...depositHistory, status: !depositHistory.status }
          : depositHistory
      )
    );
    toast({
      render: () => <ToastBox message={"Status changed succesfully.!"} />,
    });
  }, 300);

  const filteredData = data?.data?.rows
    .filter((item) => {
      // Filter by name (case insensitive)
      const name = [item.firstName, item.lastName, item.countryName]
        .filter(Boolean)
        .join(" ");
      const searchLower = searchTerm.toLowerCase();
      const nameMatches = name.toLowerCase().includes(searchLower);

      // Filter by status (Uncomment and use if needed)
      // const status = item.status;
      // const statusLower = status ? "active" : "inactive";

      // const statusMatches =
      //   statusFilter === "all" ||
      //   (statusFilter === "active" && status === true) ||
      //   (statusFilter === "inactive" && status === false);

      return nameMatches;
    })
    .sort((b, a) => new Date(a.createdAt) - new Date(b.createdAt));

  // const handleView = (id) => {
  //   setActionId(id);
  //   onViewOpen();
  // };

  const extractedArray = data?.data?.rows?.map((item, idx) => ({
    "Sr.no": (
      <Text
        w={"10px"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {generateSerialNumber(idx, currentPage, pageSize)}
      </Text>
    ),
    "Request Date": (
      <Text
        w={"60px"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {formatDate(item?.isReversalDate)}
      </Text>
    ),
    "Client ID": (
      <Text
        w={"60px"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {item?.clientReference_id}
      </Text>
    ),
    "First Name": (
      <Box isTruncated={true} w={"60px"}>
        <Text as={"span"} color={"teal.900"} fontWeight={"500"}>
          {item?.firstName}
        </Text>
      </Box>
    ),
    "Last Name": (
      <Box w={"70px"} isTruncated={true}>
        <Text as={"span"} color={"teal.900"}>
          {item?.lastName}
        </Text>
      </Box>
    ),
    Country: (
      <Box  isTruncated={true}>
        <Text as={"span"} color={"teal.900"}>
          {item?.countryName}
        </Text>
      </Box>
    ),
    "Phone Number": (
      <Box  isTruncated={true}>
        <Text as={"span"} color={"teal.900"}>
          {item?.ISDCode} {item?.mobileNumber}
          {/* {item?.ISDcode + " " + item?.mobileNumber} */}
        </Text>
      </Box>
    ),
    "Deposit Amount": (
      <Box isTruncated={true} display={"flex"} justifyContent={"end"}>
        <Text as={"span"} color={"teal.900"} textAlign={"right"}>
          {parseFloat(item?.investorAmount || 0).toLocaleString(undefined, {
            minimumFractionDigits: 2,
            maximumFractionDigits: 2,
          })}
          <Badge ms={1} colorScheme="green">
            {item?.currencyCode}
          </Badge>
        </Text>
      </Box>
    ),
    Action: (
      <Box display={"flex"} justifyContent={"center"} gap={2}>
        <Tooltip
          rounded={"sm"}
          fontSize={"xs"}
          label="Approve"
          bg="#fff"
          color={"green.500"}
          placement="left-start"
        >
          <Button
            rounded={"sm"}
            size={"xs"}
            textTransform={"inherit"}
            fontWeight={500}
            px={2}
            py={1}
            onClick={() => {
              setActionId(item.id);
              onConfirmOpen();
            }}
            colorScheme="green"
            variant={"solid"}
            cursor={"pointer"}
          >
            <CheckIcon fontSize={"12px"} />
          </Button>
        </Tooltip>
        <Tooltip
          rounded={"sm"}
          fontSize={"xs"}
          label="Reject"
          bg="#fff"
          color={"red.500"}
          placement="left-start"
        >
          <Button
            colorScheme="red"
            // color="red.500"
            rounded={"sm"}
            size={"xs"}
            textTransform={"inherit"}
            fontWeight={500}
            px={2}
            onClick={() => {
              setActionId(item.id);
              onRejectOpen();
            }}
            py={1}
            // variant={"solid"}
          >
            <CloseIcon fontSize={"10px"} />
          </Button>
        </Tooltip>
      </Box>
    ),
  }));

  const handleDelete = () => {
    const IOtype = investmentType.filter(
      (investmentType) => investmentType.id !== actionId
    );

    setTimeout(() => {
      setInvestmentType(IOtype);
      setDeleteAlert(false);
      setIsLoading(false);
    }, 100);
    setIsLoading(true);
  };

  const handleApproved = async (data) => {
    setIsReversalLoading.on(); // Start loading
    try {
      const { error, data: responseData } = await rejectbankDepositRequest({
        id: actionId,
        data,
      });

      if (error) {
        throw error; // Explicitly handle the error
      }

      // Success: Perform necessary actions
      refetch();
      toast({
        render: () => (
          <ToastBox message={responseData?.message || "Action successful!"} />
        ),
      });
      onRejectClose();
    } catch (error) {
      // Handle errors
      toast({
        render: () => (
          <ToastBox
            message={
              error?.data?.message || "Something went wrong. Please try again."
            }
            status="error"
          />
        ),
      });
      console.error("Error:", error);
    } finally {
      setIsReversalLoading.off(); // Ensure loading is toggled off
    }
  };

  const handleConfirm = async (data) => {
    
    setIsReversalLoading.on(); // Start loading
    try {
      const { error, data: responseData } = await approveBankDepositRequest({
        id: actionId,
        data,
      });

      if (error) {
        throw error; // Explicitly handle the error
      }

      // Success: Perform necessary actions
      refetch();
      toast({
        render: () => (
          <ToastBox message={responseData?.message || "Action successful!"} />
        ),
      });
      onRejectClose();
    } catch (error) {
      // Handle errors
      toast({
        render: () => (
          <ToastBox
            message={
              error?.data?.message || "Something went wrong. Please try again."
            }
            status="error"
          />
        ),
      });
      console.error("Error:", error);
    } finally {
      setIsReversalLoading.off(); // Ensure loading is toggled off
    }
  };

  return (
    <Box {...OPACITY_ON_LOAD} overflowY={"scroll"} height={"100vh"} pb={38}>
      {/* <ConfirmModal isOpen={isConfirmOpen} onClose={onConfirmClose} /> */}
      <RejectReversalPopups
        isOpen={isRejectOpen}
        onClose={onRejectClose}
        handelApproved={handleApproved}
        isLoading={isReversalLoading}
      />
      <ConfirmReversalPopups
        isOpen={isConfirmOpen}
        onClose={onConfirmClose}
        handleConfirm={handleConfirm}
        isLoading={isReversalLoading}
      />
      <Box bg="white.500">
        <HStack
          display={"flex"}
          justifyContent={"space-between"}
          ps={1}
          pe={1}
          pb={4}
          pt={4}
          spacing="24px"
        >
          <Input
            type="search"
            width={300}
            placeholder="Search..."
            size="sm"
            rounded="sm"
            focusBorderColor="green.500"
            value={searchTerm}
            onChange={(e) => setSearchTerm(e.target.value)}
          />

          <HStack display={"flex"} alignItems={"center"}>
            <Pagination
              isLoading={depositHistoryLoading}
              pageSize={pageSize}
              setPageSize={setPageSize}
              currentPage={currentPage}
              setCurrentPage={setCurrentPage}
              totalItems={data?.data?.totalItems}
            />
          </HStack>
        </HStack>
      </Box>

      <NormalTable
        emptyMessage={`We don't have any Investment type `}
        tableHeadRow={tableHeadRow}
        // setData={setExtractedArray}
        data={extractedArray}
        isLoading={depositHistoryLoading}
        viewActionId={actionId}
        setViewActionId={setActionId}
        setMouseEnteredId={setMouseEnteredId}
        setMouseEntered={setMouseEntered}
      />

      <CustomAlertDialog
        onClose={() => setDeleteAlert(false)}
        isOpen={deleteAlert}
        message={"Are you sure you want to delete sponers?"}
        alertHandler={handleDelete}
        isLoading={isLoading}
      />
    </Box>
  );
};

export default BankDepositRequest;
